// This class creates and uses two custom form arrays called:
// aList1 and aList2

class ItemMoverContainer(parentObj, name) of ZCONTAINER(parentObj, name) custom
   with (this)
      onMouseMove = {;class::FlashButton_BlinkOff()}
      left = 2
      top = 0
      width = 90
      height = 10.5
      metric = 0	// Chars
   endwith


   this.TEXT1 = new ZTEXT(this)
   with (this.TEXT1)
      height = 1
      left = 3.2857
      top = 0.4091
      width = 30.5714
      text = "Item List 1"
   endwith


   this.ADDBUTTON = new POPBUTTON(this)
   with (this.ADDBUTTON)
      onClick = class::ADDBUTTON_ONCLICK
      height = 1.3182
      left = 39.4286
      top = 4.2727
      width = 12
      text = "&Add"
      upBitmap = "RESOURCE #100"
      speedTip = "Add the highlighted Item"
      value = false
      textLeft = true
   endwith


   this.REMOVEBUTTON = new POPBUTTON(this)
   with (this.REMOVEBUTTON)
      onClick = class::REMOVEBUTTON_ONCLICK
      height = 1.3182
      left = 39.4286
      top = 5.9091
      width = 12
      text = "&Remove"
      upBitmap = "RESOURCE #104"
      speedTip = "Remove the highlighted item"
      value = false
   endwith


   this.LISTBOX1 = new ZLISTBOX(this)
   with (this.LISTBOX1)
      height = 8.7727
      left = 2.8571
      top = 1.2273
      width = 36.1429
      onLeftDblClick = Class::ListBox1_OnLeftDblClick
   endwith


   this.TEXT2 = new ZTEXT(this)
   with (this.TEXT2)
      height = 0.7273
      left = 52
      top = 0.4091
      width = 20.1429
      text = "Item List 2"
   endwith


   this.LISTBOX2 = new ZLISTBOX(this)
   with (this.LISTBOX2)
      height = 8.7727
      left = 51.8571
      top = 1.2273
      width = 35.7143
      onLeftDblClick = Class::ListBox2_OnLeftDblClick
   endwith

   form.aList1 = {"Item 1","Item 2","Item 3"}
   form.aList2 = New Array()

   this.ListBox1.Datasource = "ARRAY form.aList1"
   this.ListBox2.Datasource = "ARRAY form.aList2"

   function OnOpen
      this.CheckSort()
   return

   function ADDBUTTON_onClick
      this.parent.AddToList2()
   return


   function REMOVEBUTTON_onClick
      this.parent.AddToList1()
   return

   Function ListBox1_OnLeftDblClick
      this.parent.AddToList2()
   return

   Function ListBox2_OnLeftDblClick
      this.parent.AddToList1()
   return


   Function AddToList2()
   local n

      oldExact = set("EXACT")
      set exact ON
      if this.listbox1.cursel > 0
         form.aList2.Add(form.aList1[this.listbox1.cursel])
         n = form.aList1.Scan(form.aList1[this.Listbox1.cursel])
*         msgbox(n+"super")
         set exact &oldExact.
         Class::DeleteFromList1(n)
         this.ReState()
         this.CheckSort()
      endif
      
   return

   Function AddToList1()
   local n

      oldExact = set("EXACT")
      set exact ON
      if this.listbox2.cursel > 0
         form.aList1.Add(form.aList2[this.listbox2.cursel])
         n = form.aList2.Scan(form.aList2[this.Listbox2.cursel])
         set exact &oldExact.
         Class::DeleteFromList2(n)
         this.Restate()
         this.CheckSort()
      endif
   return


   Function DeleteFromList1(n)
*      msgbox(n+"???")
      if form.aList1.Size > 1
         form.aList1.Delete(n)
         form.aList1.resize(form.aList1.size - 1)
      else
         form.aList1 = New Array()
      endif
   return

   Function DeleteFromList2(n)
      if form.aList2.Size > 1
         form.aList2.Delete(n)
         form.aList2.resize(form.aList2.size - 1)
      else
         form.aList2 = New Array()
      endif
   return

   Function Restate
      this.Listbox1.datasource = this.Listbox1.datasource
      this.Listbox2.datasource = this.Listbox2.datasource
   return

   function CheckSort
      if this.ListBox1.Sorted
         form.aList1.Sort()
      endif

      if this.Listbox2.Sorted
         form.aList2.Sort()
      endif
   return
endclass

