// -- Metric: 0 - Chars and 6 - Pixels Only

***************************************************************
// Posted in the Visual dBASE newsgroups, July 17, 1999
// Font.cc
// A container to let the user specify a font
// By Peter Rorlick
// For Visual dBASE 7.01
// Usage:
//    SET PROCEDURE TO FONT.CC ADDITIVE
//    // in the form designer, drop an instance of
//    // FontContainer onto a form, and run the form ...
***************************************************************
class FontContainer(parentObj) of CONTAINER(parentObj) custom
   with (this)
      left = 6.2857
      top = 1.0909
      width = 52.2857
      height = 3.4091
      metric = 0        // Chars
   endwith


   this.TEXT1 = new TEXT(this)
   with (this.TEXT1)
      height = 1
      left = 1.7143
      top = 0.5909
      width = 5.8571
      wrap = false
      alignVertical = 1        // Middle
      text = "Font"
   endwith


   this.FontName = new ENTRYFIELD(this)
   with (this.FontName)
      height = 1
      left = 8.4286
      top = 0.5909
      width = 41.1429
      value = "                         "
   endwith


   this.FontBtn = new sBUTTON(this)
   with (this.FontBtn)
      onClick = class::FONTBTN_onClick
      height = 0.8636
      left = 46.1429
      top = 0.6818
      width = 3.1429
      text = ""
      upBitmap = "RESOURCE #148"
      value = false
   endwith


   this.TEXT2 = new TEXT(this)
   with (this.TEXT2)
      height = 1
      left = 8.4286
      top = 1.7727
      width = 4.4286
      wrap = false
      alignVertical = 1        // Middle
      text = "Size"
   endwith


   this.FontSize = new SPINBOX(this)
   with (this.FontSize)
      height = 1
      left = 13.7143
      top = 1.8182
      width = 9.5714
      rangeMax = 100
      rangeMin = 1
      value = 1
   endwith


   this.FontBold = new CHECKBOX(this)
   with (this.FontBold)
      height = 1.0909
      left = 29.2857
      top = 1.7727
      width = 7
      text = "&Bold"
      value = false
   endwith


   this.FontItalic = new CHECKBOX(this)
   with (this.FontItalic)
      height = 1.0909
      left = 42
      top = 1.7727
      width = 7.1429
      text = "&Italic"
      value = false
   endwith

   function onDesignOpen( lFromPalette )
      if lFromPalette and form.metric == 6 // Pixels
         this.height :=  75
         this.width  := 366
         this.FontBold.height := 24
         this.FontBold.width  := 49
         this.FontBold.left   := 205
         this.FontBold.top    := 39
         this.FontItalic.height := 24
         this.FontItalic.width  := 50
         this.FontItalic.left   := 294
         this.FontItalic.top    := 39
         this.FontSize.height   := 22
         this.FontSize.width    := 67
         this.FontSize.left     := 96
         this.FontSize.top      := 40
         this.FontBtn.height    := 19
         this.FontBtn.width     := 22
         this.FontBtn.left      := 323
         this.FontBtn.top       := 15
         this.FontName.height   := 22
         this.FontName.width    := 288
         this.FontName.left     := 59
         this.FontName.top      := 13
         this.Text1.height      := 22
         this.Text1.width       := 41
         this.Text1.left        := 12
         this.Text1.top         := 13
         this.Text2.height      := 22
         this.Text2.width       := 31
         this.Text2.left        := 59
         this.Text2.top         := 39
      endif

   function FONTBTN_onClick
      local cFont
      cFont = getfont()
      if not isblank(cFont)
        this.parent.FontName.Value = left(cFont,at(',',cFont)-1)
        cFont = subs(cFont,at(',',cFont)+1)   // now it's nSize,[B][I],cSwiss
        this.parent.FontSize.Value = val(left(cFont,at(',',cFont)-1))
        cFont = subs(cFont,at(',',cFont)+1)   // now it's [B][I],cSwiss
        this.parent.FontBold.Value = (left(cFont,1)=='B')
        this.parent.FontItalic.Value = ('I'$left(cFont,2))
        * Form.Repaint()
      endif
   return

endclass
****************************************************
// SButton is a small square button that has no text and does
// not retain focus - e.g., good for attaching to an entryfield.
CLASS SBUTTON(FormObj) OF PUSHBUTTON(FormObj) Custom
 With (this)
      height = 1.25 // was 1.2
      width = 3.55 // was 3.5
      metric = 0
      tabStop = false
      group = true
      value = false
      text = " "
      SpeedBar = true
   EndWith
EndClass