/*
    Program...: MNU2TREE.PRG
    Author....: Jrgen Feder
    Date......: 11/16/1998

    The purpose of this program is to convert a standard
    VdB 7.01 menu file (.MNU) to a TREE style menu with the same
    selection functionality in a .cc file

-------------------------------------------------------------
SPECIAL NOTE: This program will convert your onClick event 
handlers from the menu file to onLeftMouseDown event handlers 
in the treeItems. You may however have to edit some of your 
references in the eventhandlers.


Example:

DO mnu2Tree with "MUGS.MNU"
set proc to MUGSTREE.CC additive
f=new form()
f.t=new MUGSTREE(f)
f.t.width=f.width
f.t.height=f.height
f.open()


*/

PARAM MenuFileIn,TreeFileOut
local cStr
IF TYPE('MenuFileIn')#'C'
	MenuFileIn= GetFile("*.MNU","Select MNU-file")
ENDIF
IF TYPE('TreeFileOut')#'C'
	TreeFileOut=SUBSTR(MenuFileIn,1,LEN(MenuFileIn)-4)+"TREE.CC"
ENDIF
fIn=NEW FILE()
fIn.Open(MenuFileIn,"R")
fOut=NEW FILE()
fOut.Create(TreeFileOut)
DO WHILE NOT fIn.EOF()
	cStr=fIn.ReadLn(300,CHR(10))
   IF ASC(RIGHT(cStr,1))=13
   	cStr=SUBSTR(cStr,1,len(cStr)-1)
   ENDIF
	IF left(cStr,5)="class"
   	cStr=STUFF(cStr,AT('MENUBAR',cStr),7,"TREEVIEW")
      IF 'MENU'$UPPER(cStr)
	   	cStr=STUFF(cStr,AT('MENU',UPPER(cStr)),4,"TREE")
      ENDIF
      IF NOT RIGHT(lower(trim(cStr)),6)='custom'
      	cStr=cStr+' custom'
      ENDIF
	   fOut.WriteLn(cStr)
      fOut.WriteLn('this.allowEditLabels=false')
      fOut.WriteLn('this.allowEditTree=false')
      fOut.WriteLn('this.onLeftMouseDown={;IIF(NOT EMPTY(this.selected.onclick),this.selected.onClick(),null)}')
      EXIT
   ENDIF
ENDDO
DO WHILE NOT fIn.EOF()
	cStr=fIn.ReadLn(255,CHR(10))
   IF ASC(RIGHT(cStr,1))=13
   	cStr=SUBSTR(cStr,1,len(cStr)-1)
   ENDIF
   IF "MENU(this" $ cStr 
   	cStr=STUFF(cStr,AT('MENU(',cStr),5,"MENUTREEITEM(")
   ENDIF
   IF LEFT(LTRIM(cStr),4)="text"
   	cStr=STUFF(cStr,AT('&',cStr),1,'')
   ENDIF
   fOut.WriteLn(cStr)
ENDDO
fOut.WriteLn("CLASS MENUTREEITEM(parent,name) OF TREEITEM(parent,name) custom")
fOut.WriteLn("this.onClick=null")
fOut.WriteLn("this.statusMessage=''")
fOut.WriteLn("ENDCLASS")
fIn.Close()
fOut.Close()  
