//---------------------------------------------------------------------
// CC file.....: Splitter.cc
// ............: Version 1.0
// Author......: Elwyn Rees 
// E-mail .....: e.j.rees@cableinet.co.uk
// Date........: 29-Apr-99
// Notes.......:
// Written for.: Visual dBASE 7.01
// Rev. History:
// ............:
// Usage.......: 1. Install splitter.cc  as a Custom Component
// ............:
// ............: 2. Open a new form and set its METRICS propert to PIXELS
// ............:
// ............: 3. VertSplitter and HorizSplitter controls can be dropt
// ............:    onto a form, or any form container.
// ............: 
// ............: 4. Set Anchor property to container
// ............:
// Methods ....: 5. SetRelativeTopobj(oform.height) 
// ............:    SetRelativeLeftObj(oForm.obj.width) 
// ............: 
// Classes ....: VerticalSplitter  - A vertical splitter component
// ............: Horizsplitter	  - A horizontal splitter component
// Base CCs ...: SplitBar			  - Generic splitter bar
// ............: SplitterContainer - Generic splitter container
// ............;
// Comments ...: 
//---------------------------------------------------------------------
class VertSPLITTER(parentObj, name) of SPLITTERCONTAINER(parentObj, name) custom 
   protect this.splitterbar
   with (this)
      left = 0
      top = 0
      width = 605
      height = 400
      metric = 6	            // Pixels
      colorNormal = "white"
      anchor = 6	            // container
      borderStyle = 3	      // None
   endwith

   this.CHILDCONTAINER1 = new CONTAINER(this)
   with (this.CHILDCONTAINER1)
      left = 0
      top = 0
      width = 200
      height = 200
      borderStyle = 3	      // None
      pageno = 0
      anchor = 2	            // TOP  'CHANGED FROM HORIZ SPLITTER'
   endwith

   this.SPLITTERBAR = new splitbar(this)
   with (this.SPLITTERBAR)
      left = 347
      top = 0
      width = 200            // HEIGHT AND WIDTH REVERSED COMPARED HORIZSPLITTER
      height = 10
      mousePointer = 7	     // Size S  'CHANGED FORM HORIZSPLITTER'
      pageno = 0
      anchor = 2	           // TOP ' CHANGED FROM HORIZ SPLITTER'
      splittertype = "vertical"
   endwith


   this.CHILDCONTAINER2 = new CONTAINER(this)
   with (this.CHILDCONTAINER2)
      left = 359
      top = 0
      width = 240
      height = 394
      borderStyle = 3	     // None
      pageno = 0
      anchor = 6	           // Container
   endwith



endclass
// EOC: VerticalSplitter


class HorizSPLITTER(parentObj, name) of SPLITTERCONTAINER(parentObj, name) custom 
   protect this.splitterbar
   with (this)
      left = 0
      top = 0
      width = 605
      height = 400
      metric = 6	           // Pixels
      colorNormal = "white"
      anchor = 6	           // Container
      borderStyle = 3	     // None
   endwith

   this.CHILDCONTAINER1 = new CONTAINER(this)
   with (this.CHILDCONTAINER1)
      left = 0
      top = 0
      width = 347
      height = 394
      borderStyle = 3	     // None
      pageno = 0
      anchor = 3	           // Left
   endwith





   this.SPLITTERBAR = new SPLITBAR(this)
   with (this.SPLITTERBAR)
      left = 347
      top = 0
      width = 10
      height = 394
      mousePointer = 9	// Size E
      pageno = 0
      anchor = 3	// Left
      splittertype = "HORIZONTAL"
   endwith


   this.CHILDCONTAINER2 = new CONTAINER(this)
   with (this.CHILDCONTAINER2)
      left = 359
      top = 0
      width = 240
      height = 394
      borderStyle = 3	// None
      pageno = 0
      anchor = 6	// Container
   endwith


endclass
// EOC: HorizSplitter


class SPLITBAR(parentObj, name) of CONTAINER(parentObj, name) custom
//-----------------------------------------------------------------------
// Description ....: The 'Splitter Bar'
// Function .......: Creates WinAPI functIons
// ................: Contains a Generic splitter 'ResizeObjects' method
// Custom property.: 'SplitterType' (HORIZONTAL or VERTICAL)
//-----------------------------------------------------------------------
	protect onLeftMouseDown

   // Custom properties
   this.splittertype = "horizontal"

   with(this)
      onLeftMouseDown = class::SPLITTERBAR_ONLEFTMOUSEDOWN
   endwith


   Procedure ResizeObjects(oObj,oSplitterbar)
   //---------------------------------------------------------------------
   // Method of base splitter bar class
   // Programmer..: Elwyn Rees
   // Date........: 4-May-1999
   // Notes.......: 
   // ............: 
   // Written for.: Visual dBASE (32-bit versions)
   // Rev. History: 
   // Dependancies: Calls methods in Splittercontainer class
   // Calls.......: GetRelativeLeftPos, GetRelativeTopPos
   //             :
   // Called by...: SplitterBar_OnLeftMouseDown()
   // Usage.......: 
   // Returns.....: None
   // Parameters..: oObj = object refernce to containerchildA of splitter obj
   // ............: oSplitterbar = object reference to splitter bar rectangle
   // Comments ...: Action depends on Horiz or Vertical splitter
   //---------------------------------------------------------------------
   * What sort of splitter?
   if upper(	this.splittertype 	) == "HORIZONTAL"
	   oobj.width = (oSplitterbar.left  - oobj.parent.GetRelativeleftPos() )
   elseif upper(	this.splittertype	) == "VERTICAL"
   	oobj.height = (oSplitterbar.Top - oobj.parent.GetRelativeTopPos() )
   endif

   * Call parent SplitterOnsize method
   this.parent.SplitterOnsize()


   * Update screen
	   oobj.parent.width = oobj.parent.width+1 // forces 'Anchor' objects
	   oobj.parent.width = oobj.parent.width-1 // to resize
      updateWindow(form.hWndclient)

   return



   PROCEDURE SplitterBar_OnLeftMouseDown
   //---------------------------------------------------------------------
   // Programmer..: Elwyn Rees
   // Date........: 4-May-1998
   // Notes.......: 
   // ............: 
   // Written for.: Visual dBASE (32-bit versions)
   // Rev. History: 
   // Calls.......: oPoint, oMouse, WinAPIDragDetect(), 
   //             :
   // Called by...: 
   // Usage.......: 
   // Returns.....: 
   // Parameters..:
   // Description.: The splitterbar border style is changed to show the 
   // ............: user that the bar has been 'grabbed'.
   // ............:
   //	............: A rectnagle is created at the current mouse position
   // ............: The rectangle created is considerable larger than the
   // ............: parent window so that its ends can't be seen.  This is
   // ............; a horrible kludge since I haven't figured out how to
   // ............: limit the mouse movement to a single axis.
   // ............: 
   // ............: A winAPI dragdetect is performed, and if true, the
   // ............: ResizeObjects() method is called. 
   //---------------------------------------------------------------------
   #define WM_LBUTTONDOWN      513
   #define WM_LBUTTONUP        514
   #define WM_NCMOUSEMOVE      htoi ("00A0")
   #define WM_NCLBUTTONDOWN    htoi ("00A1")
   #define WM_NCLBUTTONUP      htoi ("00A2")
   #define WM_NCLBUTTONDBLCLK  htoi ("00A3")
   #define WM_NCRBUTTONDOWN    htoi ("00A4")
   #define WM_NCRBUTTONUP      htoi ("00A5")
   #define WM_NCRBUTTONDBLCLK  htoi ("00A6")
   #define WM_NCMBUTTONDOWN    htoi ("00A7")
   #define WM_NCMBUTTONUP      htoi ("00A8")
   #define WM_NCMBUTTONDBLCLK  htoi ("00A9")
   #define HTCAPTION           2


	* Extern the WinAPI calls

   *if type("WinAPIGetCursorPos") # "FP"
   *        extern CVOID WinAPIGetCursorPos (CPTR) USER32  from "GetCursorPos"
   *endif
   
   if type("WinAPILockWindowUpdate") # "FP"
           extern CLOGICAL WinAPILockWindowUpdate (CHANDLE) USER32  from "LockWindowUpdate"
   endif
   
   
   if type("WinAPIDragDetect") # "FP"
                extern CLOGICAL WinAPIDragDetect (CHANDLE, CPTR) USER32  from "DragDetect" && undoc
   endif
   
   
   if type("WinAPISendMessage") # "FP"
                extern CLONG WinAPISendMessage (CHANDLE, CWORD, CWORD, CLONG) USER32  from "SendMessageA"
   endif

   
   IF TYPE("SETPARENT") # "FP"
      extern chandle SetParent(chandle, chandle) user32
   ENDIF

	if type("UpdateWindow") # "FP" 
   extern cLogical UpdateWindow(; 
								cHandle; 
								); 
                        user32 
	endif



   * Highlight splitterbar
       this.oldborderstyle = this.borderstyle
       this.borderstyle = 8


   * Freeze the form
      WinAPILockWindowUpdate(form.hwndclient)   // prevents the rectangle
      														// from being shown
         *
         *
         * Set Top and Left relative positions
         this.parent.SetrelativeLeft() 
         this.parent.SetrelativeTop()  


         * Create splitter bar rectangle 
         if upper( this.splittertype ) == "HORIZONTAL"
         * create a Vertical rectangle
         	form.oScrollRect              = new rectangle(form)
	         form.oScrollRect.left         = this.left
	         form.oScrollRect.width        = this.width
	         form.oScrollRect.height       = this.height * 4
  	         form.oScrollRect.top          = -(this.parent.height *2)

         elseif upper( this.splittertype ) == "VERTICAL"
         * create a horizontal rectangle
	         form.oScrollRect               = new rectangle(form)
	         form.oScrollRect.Top           = this.Top
	         form.oScrollRect.width         = this.width  * 8 
	         form.oScrollRect.height        = this.height		
	         form.oScrollRect.left          = this.parent.left - (this.width* 4)
         endif


         * Set Rectangles parent window to splitter container
         setparent( form.oScrollrect.hWnd, this.parent.hwnd)
            *
            *
            * Drag a Rectangle about
            if WinAPIDragDetect (form.oScrollRect.hwnd,0) 

                                         
               WinAPISendMessage (form.oScrollRect.hWnd,;
               						 WM_NCLBUTTONDOWN,;
                                   HTCAPTION,;
                                    0)

               form.mousepointer = 0 // default


               this.resizeobjects(this.parent.ChildContainer1,;
               							form.oScrollRect)
                                                 
            endif
            *
            *
         form.oScrollRect.release()
         form.oScrollRect = null
         *
         *
         * 
     WinAPILockWindowUpdate(0)

   * Reset splitterbar properties
     this.borderstyle = this.oldborderstyle
   RETURN 



endclass
// EOC: SplitBar



class SPLITTERCONTAINER(parentObj, name) of CONTAINER(parentObj, name) custom
	//	A parent container for the three splitter sub-components
	// (childA, splitterBar and childB - Not in this class)

   // Protect private properties 
   protect RelativeTopPos,;
           RelativeTopObjProp,;
           RelativeLeftPos,;
           RelativeLeftObjProp

   // Custom properties
	this.RelativeLeftPos = 0
   this.RelativeTopPos = 0
   this.RelativeLeftObjProp = NULL
   this.RelativeTopObjProp = NULL 
 

   // Set Default properties and events
   with (this)
      left = 0
      top = 0
      width = 605
      height = 400
      metric = 6	// Pixels
      colorNormal = "white"
      anchor = 0	// None
      borderStyle = 3	// None
   endwith


   Function GetRelativeLeftPos
   //---------------------------------------------------------------------
   // method of splitter parent container
   return this.relativeleftpos

   Function GetRelativeTopPos
   //---------------------------------------------------------------------
   // method of splitter parent container
   return this.relativeToppos

   Procedure SetRelativeLeftObj(oObjProp)
   //---------------------------------------------------------------------
   // method of splitter parent container
   // Assigns a form object property to a custom property of splitter
   // for relative positioning of the Horizontal splitter bar
   // oObjProp is a property of a form object
   //
   // This only assigns the object property not the property value!
   //---------------------------------------------------------------------
   this.RelativeLeftObjProp = oObjProp


   Procedure SetRelativeTopObj(oObjProp)
   //---------------------------------------------------------------------
   // method of splitter parent container
   // Assigns a form object property to a custom property of splitter
   // for relative positioning of the Vertical splitter bar
   // oObjProp is a property of a form object
	//
   // This only assigns the object property not the property value!
   //---------------------------------------------------------------------
   this.RelativeTopObjProp = oObjProp

   Procedure SetRelativeLeft
   //---------------------------------------------------------------------
   //  Assigns object property to custom splitter property
   if this.RelativeLeftObjProp # NULL
   	this.RelativeLeftPos = this.RelativeLeftObjProp
   endif

   Procedure SetRelativeTop
   //---------------------------------------------------------------------
   // method of splitter parent container
   // Assigns object property to custom splitter property
   if this.relativeTopObjProp # NULL
   	this.RelativeTopPos	= this.RelativeTopObjProp
	endif
     

   Procedure SplitterOnSize
   //---------------------------------------------------------------------
	// Function..: Called by splitterbar during ResizeObjects Method
   // Use ......: Overide in the splitter.OnOpen method to resize objects 
   // ..........: e,g those without an anchor property such as TreeView
   //---------------------------------------------------------------------
   return
   


endclass
// EOC: Splittercontainer

